import app from "flarum/admin/app";
import type Client from "src/common/models/Client";

import EditModelModal from "./EditModelModal";
import { NestedStringArray } from "@askvortsov/rich-icu-message-formatter";
import { randomString } from "../util";

export default class EditApplicationModal extends EditModelModal<Client> {
    modelType(): string {
        return "oauth-clients";
    }

    fields() {
        return [
            'client_id',
            'client_secret',
            'redirect_uri',
            'grant_types',
            'scope',
            'client_name',
            'client_desc',
            'client_icon',
            'client_home'
        ];
    }

    defaultValues() {
        return {
            client_id: randomString(32),
            client_secret: randomString(32)
        };
    }

    translateFieldName(field: string): NestedStringArray {
        return app.translator.trans("rhodes-island-oauth-center.admin.clients." + field);
    }

    className(): string {
        return "OAuth-EditApplication";
    }
    title() {
        return app.translator.trans("rhodes-island-oauth-center.admin.clients.edit_modal_title_" + (this.model ? "edit" : "add"));
    }
}