import app from 'flarum/admin/app';
import SettingsPage from './components/SettingsPage';
app.initializers.add('foskym/flarum-oauth-center', () => {
  app.extensionData
    .for('rhodes-island-oauth-center')
    .registerPage(SettingsPage)
    .registerPermission(
      {
        icon: 'fas fa-user-friends',
        label: app.translator.trans('rhodes-island-oauth-center.admin.permission.use_oauth'),
        permission: 'rhodes-island-oauth-center.use-oauth',
      },
      'view',
      95
    )
    .registerSetting({
      label: app.translator.trans('rhodes-island-oauth-center.admin.settings.allow_implicit'),
      setting: "rhodes-island-oauth-center.allow_implicit",
      type: "boolean"
    })
    .registerSetting({
      label: app.translator.trans('rhodes-island-oauth-center.admin.settings.enforce_state'),
      setting: "rhodes-island-oauth-center.enforce_state",
      type: "boolean"
    })
    .registerSetting({
      label: app.translator.trans('rhodes-island-oauth-center.admin.settings.require_exact_redirect_uri'),
      setting: "rhodes-island-oauth-center.require_exact_redirect_uri",
      type: "boolean"
    })
    .registerSetting({
      label: app.translator.trans('rhodes-island-oauth-center.admin.settings.use_redirect_authorize'),
      setting: "rhodes-island-oauth-center.use_redirect_authorize",
      type: "boolean"
    })
    .registerSetting({
      label: app.translator.trans('rhodes-island-oauth-center.admin.settings.access_lifetime'),
      setting: "rhodes-island-oauth-center.access_lifetime",
      type: "number"
    });
});
