<?php

namespace RhodesIsland\OAuthCenter\Api\Controller;

use Flarum\Api\Controller\AbstractCreateController;
use Flarum\Http\RequestUtil;
use Illuminate\Support\Arr;
use Psr\Http\Message\ServerRequestInterface;
use RhodesIsland\OAuthCenter\Utils;
use Tobscure\JsonApi\Document;
use RhodesIsland\OAuthCenter\Models\Client;
use RhodesIsland\OAuthCenter\Api\Serializer\ClientSerializer;

class CreateClientController extends AbstractCreateController
{
    public $serializer = ClientSerializer::class;
    protected function data(ServerRequestInterface $request, Document $document)
    {
        $actor = RequestUtil::getActor($request);
        $actor->assertAdmin();

        $attributes = Arr::get($request->getParsedBody(), 'data.attributes');

        $attrs = Utils::processAttributes($attributes, Utils::CLIENT_ATTRIBUTES, Utils::CLIENT_NULLABLE_ATTRIBUTES);
        $attrs["user_id"] = $actor->id;

        return Client::create($attrs);
    }
}
