<?php

namespace RhodesIsland\OAuthCenter\Api\Controller;

use Flarum\Api\Controller\AbstractListController;
use Flarum\Http\RequestUtil;
use Illuminate\Support\Arr;
use Psr\Http\Message\ServerRequestInterface;
use RhodesIsland\OAuthCenter\Utils;
use Tobscure\JsonApi\Document;
use RhodesIsland\OAuthCenter\Models\Client;
use RhodesIsland\OAuthCenter\Api\Serializer\ClientSerializer;

class UpdateClientController extends AbstractListController
{
    public $serializer = ClientSerializer::class;
    protected function data(ServerRequestInterface $request, Document $document)
    {
        $actor = RequestUtil::getActor($request);
        $actor->assertAdmin();

        $id = Arr::get($request->getQueryParams(), 'id');
        $client = Client::find($id);

        $attributes = Arr::get($request->getParsedBody(), 'data.attributes', []);

        $attrs = Utils::processAttributes($attributes, Utils::CLIENT_ATTRIBUTES, Utils::CLIENT_NULLABLE_ATTRIBUTES);

        foreach ($attrs as $k => $v) {
            $client[$k] = $v;
        }

        $client->save();

        return $client;
    }
}
