<?php

namespace RhodesIsland\OAuthCenter\Middlewares;

use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;

class UnsetCsrfMiddleware implements MiddlewareInterface
{
    public function process(Request $request, RequestHandlerInterface $handler): Response
    {
        $uri = [
            '/oauth/token',
            '/oauth/authorize/redirect'
        ];
        $path = $request->getUri()->getPath();
        if (in_array($path, $uri)) {
            $request = $request->withAttribute('bypassCsrfToken', true);
        }

        return $handler->handle($request);
    }
}
